package de.intevation.flys.model;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.GeneratedValue;
import javax.persistence.Column;
import javax.persistence.SequenceGenerator;
import javax.persistence.GenerationType;
import javax.persistence.JoinColumn;
import javax.persistence.OneToOne;
import javax.persistence.OneToMany;

import org.apache.log4j.Logger;




@Entity
@Table(name = "waterlevel_q_range")
public class WaterlevelQRange
implements   Serializable
{
    private static Logger logger = Logger.getLogger(WaterlevelQRange.class);

    private Integer id;

    private Waterlevel waterlevel;

    private Double q;

    private List<WaterlevelValue> values;


    public WaterlevelQRange() {
        this.values = new ArrayList<WaterlevelValue>();
    }

    public WaterlevelQRange(Waterlevel waterlevel, Double q) {
        this();
        this.q          = q;
        this.waterlevel = waterlevel;
    }


    @Id
    @SequenceGenerator(
        name           = "SEQUENCE_WATERLEVEL_Q_RANGE_ID_SEQ",
        sequenceName   = "WATERLEVEL_Q_RANGES_ID_SEQ",
        allocationSize = 1)
    @GeneratedValue(
        strategy  = GenerationType.SEQUENCE,
        generator = "SEQUENCE_WATERLEVEL_Q_RANGE_ID_SEQ")
    @Column(name = "id")
    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    @OneToOne
    @JoinColumn(name = "waterlevel_id" )
    public Waterlevel getWaterlevel() {
        return waterlevel;
    }

    public void setWaterlevel(Waterlevel waterlevel) {
        this.waterlevel = waterlevel;
    }

    @Column(name = "q")
    public Double getQ() {
        return q;
    }

    public void setQ(Double q) {
        this.q = q;
    }

    @OneToMany
    @Column(name = "waterlevel_q_range_id")
    public List<WaterlevelValue> getValues() {
        return values;
    }

    public void setValues(List<WaterlevelValue> values) {
        this.values = values;
    }

    public void addValue(WaterlevelValue value) {
        values.add(value);
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
